Status: Under Review Priority: Should have
Author: Kira Backes Category: ViewHelpers
Created: 2012-03-09 Assigned To:
Updated: 2013-11-20 Due date:
Has patch: No
Affected Flow version: Git master
Subject: Radio Button missing checked on validation error
Description

The checked state of a radio button is not properly checked in the case of a validation error, this should be checked by comparing the
value to the lastSubmittedFormData

History
#1 - 2012-03-09 13:37 - Bastian Waidelich
- Category set to ViewHelpers
- Status changed from New to Needs Feedback

Can you provide more details please (code snippet, version(s) used, ..). This should work.
Is this maybe related to #33628 ?

Thanks

#2 - 2013-02-11 20:17 - Daniel Siepmann

Perhaps it's the bug described in my blog post? http://blog.layne-obserdia.de/post/fix-radio-and-checkbox-for-fluid#comment-795695300
There is a bug fix in the post.

Or is this another issue? I noticed that submitted checkboxes and radio buttons aren't selected anymore.

So e.g. the checkbox is not selected initial.
I check it, submit the form and the form will be displayed again, on validation error, then the checkbox is no more checked.

I just fixed it for the rewritten property mapper and got the submitted value and did a compare.

#3 - 2013-07-12 18:23 - Benno Weinzierl

This bug only happens for radio buttons with name="something" and not for radio buttons specified with property="something".

Looking at the code it seems almost like a intentional behaviour:

        if ($checked === NULL && $this->isObjectAccessorMode()) {
            if ($this->hasMappingErrorOccured()) {
                $propertyValue = $this->getLastSubmittedFormData();
            } else {
                $propertyValue = $this->getPropertyValue();
            }
                // no type-safe comparison by intention
            $checked = $propertyValue == $valueAttribute;
        }

$this->isObjectAccessorMode() is the problem...

#4 - 2013-07-13 01:11 - Gerrit Code Review
- Status changed from Needs Feedback to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22272

#5 - 2013-11-20 20:58 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.Fluid has been pushed to the review server.
It is available at https://review.typo3.org/22272
